/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ContactEditableLanguage type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactEditableLanguage{}

// ContactEditableLanguage struct for ContactEditableLanguage
type ContactEditableLanguage struct {
	// Indicates the source of language info
	Source string `json:"source"`
	// Flag to mark language as primary for contact
	Primary bool `json:"primary"`
	// 2-letter ISO code (en, de...)
	Locale string `json:"locale"`
}

// NewContactEditableLanguage instantiates a new ContactEditableLanguage object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactEditableLanguage(source string, primary bool, locale string) *ContactEditableLanguage {
	this := ContactEditableLanguage{}
	this.Source = source
	this.Primary = primary
	this.Locale = locale
	return &this
}

// NewContactEditableLanguageWithDefaults instantiates a new ContactEditableLanguage object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactEditableLanguageWithDefaults() *ContactEditableLanguage {
	this := ContactEditableLanguage{}
	return &this
}

// GetSource returns the Source field value
func (o *ContactEditableLanguage) GetSource() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Source
}

// GetSourceOk returns a tuple with the Source field value
// and a boolean to check if the value has been set.
func (o *ContactEditableLanguage) GetSourceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Source, true
}

// SetSource sets field value
func (o *ContactEditableLanguage) SetSource(v string) {
	o.Source = v
}

// GetPrimary returns the Primary field value
func (o *ContactEditableLanguage) GetPrimary() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Primary
}

// GetPrimaryOk returns a tuple with the Primary field value
// and a boolean to check if the value has been set.
func (o *ContactEditableLanguage) GetPrimaryOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Primary, true
}

// SetPrimary sets field value
func (o *ContactEditableLanguage) SetPrimary(v bool) {
	o.Primary = v
}

// GetLocale returns the Locale field value
func (o *ContactEditableLanguage) GetLocale() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Locale
}

// GetLocaleOk returns a tuple with the Locale field value
// and a boolean to check if the value has been set.
func (o *ContactEditableLanguage) GetLocaleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Locale, true
}

// SetLocale sets field value
func (o *ContactEditableLanguage) SetLocale(v string) {
	o.Locale = v
}

func (o ContactEditableLanguage) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactEditableLanguage) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["source"] = o.Source
	toSerialize["primary"] = o.Primary
	toSerialize["locale"] = o.Locale
	return toSerialize, nil
}

type NullableContactEditableLanguage struct {
	value *ContactEditableLanguage
	isSet bool
}

func (v NullableContactEditableLanguage) Get() *ContactEditableLanguage {
	return v.value
}

func (v *NullableContactEditableLanguage) Set(val *ContactEditableLanguage) {
	v.value = val
	v.isSet = true
}

func (v NullableContactEditableLanguage) IsSet() bool {
	return v.isSet
}

func (v *NullableContactEditableLanguage) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactEditableLanguage(val *ContactEditableLanguage) *NullableContactEditableLanguage {
	return &NullableContactEditableLanguage{value: val, isSet: true}
}

func (v NullableContactEditableLanguage) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactEditableLanguage) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


